
 /********* Begin Procedure Script ************/
 BEGIN
	/*获取一条记录，开始时间和结束时间*/
	selectTemp=SELECT
				ADD_DAYS(startDate,-1) AS STARTDATE,
				endDate AS ENDDATE
	FROM SYS.DUMMY;

	/*获取多条记录----开始时间到结束时间*/
	mulDate=SELECT
			ADD_DAYS(A.STARTDATE, B.ROW_ID) AS STARTDATE,
			ENDDATE
			FROM :selectTemp AS A
			INNER JOIN MHP_OEE.REPORT_INDEX AS B
			ON B.ROW_ID <= DAYS_BETWEEN(A.STARTDATE, A.ENDDATE);

	resrceTable_r = SELECT
					HANDLE,
					SITE,
					RESRCE,
					DESCRIPTION,
					ASSET,
					WORK_AREA,
					LINE_AREA
	FROM MHP_OEE.RESRCE
	WHERE SITE=:site;

	resrceTable_r = APPLY_FILTER(:resrceTable_r, :workArea);

	/*关联设备的三张表和生产区域的两张表*/
	resrceTable = SELECT
					R.HANDLE,
					R.SITE,
					R.RESRCE,
					R.DESCRIPTION AS RESRCE_DESC,
					R.ASSET,
					R.WORK_AREA,
					R.LINE_AREA,
					RTR.RESOURCE_BO,
					RT.RESOURCE_TYPE,
					RT.DESCRIPTION AS RESOURCE_TYPE_DESCRIPTION,
					RT.ENABLED
	FROM :resrceTable_r AS R
	INNER JOIN MHP_OEE.RESOURCE_TYPE_RESOURCE AS RTR ON RTR.RESOURCE_BO=R.HANDLE
	INNER JOIN MHP_OEE.RESOURCE_TYPE AS RT ON RT.HANDLE=RTR.RESOURCE_TYPE_BO
	WHERE RT.ENABLED='true';



	/*取拉线描述*/
	resrceTable_add_linedesc=SELECT
					A.HANDLE,
					A.SITE,
					A.RESRCE,
					A.RESRCE_DESC,
					A.ASSET,
					A.WORK_AREA,
					A.LINE_AREA,
					B.DESCRIPTION AS LINE_AREA_DESC,
					A.RESOURCE_BO,
					A.RESOURCE_TYPE_DESCRIPTION,
					A.RESOURCE_TYPE
					FROM :resrceTable AS A
					LEFT JOIN MHP_OEE.WORK_CENTER AS B ON B.WORK_CENTER=A.LINE_AREA;

	filter_work_center=SELECT
						WC.HANDLE,
						WC.SITE,
						WC.WORK_CENTER AS WORK_AREA,
						WC.HANDLE AS WORK_CENTER_BO
						from MHP_OEE.WORK_CENTER AS WC
						WHERE  WC.SITE=:site;

	filter_work_center = APPLY_FILTER(:filter_work_center, :workArea);


	/*取班次描述*/
	resrceTable_shift=SELECT
					A.HANDLE,
					A.SITE,
					A.RESRCE,
					A.RESRCE_DESC,
					A.ASSET,
					A.WORK_AREA,
					A.LINE_AREA,
					A.LINE_AREA_DESC,
					/*WC.WORK_CENTER,*/
					WC.HANDLE AS WORK_CENTER_BO,
					WCS.SHIFT,
					WCS.DESCRIPTION AS SHIFT_DESC,
					WCS.SHIFT_DURATION AS SHIFT_DURATION,
					WCS.START_TIME,
					WCS.END_TIME,
					A.RESOURCE_BO,
					A.RESOURCE_TYPE_DESCRIPTION,
					A.RESOURCE_TYPE
					FROM :resrceTable_add_linedesc AS A
	INNER JOIN :filter_work_center AS WC ON WC.SITE=A.SITE AND A.WORK_AREA = WC.WORK_AREA
	INNER JOIN MHP_OEE.WORK_CENTER_SHIFT AS WCS ON WCS.WORK_CENTER_BO=WC.HANDLE AND WCS.ENABLED='true';


	resrceTable_shift = APPLY_FILTER(:resrceTable_shift, :lineArea);
	resrceTable_shift = APPLY_FILTER(:resrceTable_shift, :resourceType);
	resrceTable_shift = APPLY_FILTER(:resrceTable_shift, :resrce);
	resrceTable_shift = APPLY_FILTER(:resrceTable_shift, :shift);


	/*交叉组合多条记录*/
	resrce_shift_start_date_time=SELECT
		A.HANDLE,
		A.SITE,
		A.RESRCE,
		A.RESRCE_DESC,
		A.ASSET,
		A.WORK_AREA,
		A.LINE_AREA,
		A.LINE_AREA_DESC,
		A.WORK_CENTER_BO,
		A.SHIFT,
		A.SHIFT_DESC,
		A.SHIFT_DURATION,
	    CAST(CAST(B.STARTDATE AS NVARCHAR) || ' ' || CAST(A.START_TIME AS NVARCHAR) AS SECONDDATE) AS SHIFT_START_DATE_TIME,
		A.RESOURCE_BO,
		A.RESOURCE_TYPE_DESCRIPTION,
		A.RESOURCE_TYPE,
		B.STARTDATE
		FROM :resrceTable_shift AS A INNER JOIN :mulDate AS B ON 1=1;

	resrce_shift_end_date_time=SELECT
		A.HANDLE,
		A.SITE,
		A.RESRCE,
		A.RESRCE_DESC,
		A.ASSET,
		A.WORK_AREA,
		A.LINE_AREA,
		A.LINE_AREA_DESC,
		A.WORK_CENTER_BO,
		A.SHIFT,
		A.SHIFT_DESC,
		A.SHIFT_DURATION,
		A.SHIFT_START_DATE_TIME,
		ADD_SECONDS(A.SHIFT_START_DATE_TIME, A.SHIFT_DURATION) AS SHIFT_END_DATE_TIME,
		A.RESOURCE_BO,
		A.RESOURCE_TYPE_DESCRIPTION,
		A.RESOURCE_TYPE,
		A.STARTDATE
		FROM :resrce_shift_start_date_time AS A;


		filter_resrce_shift_end_date_time=SELECT
						A.HANDLE,
						A.SITE,
						A.RESRCE,
						A.RESRCE_DESC,
						A.ASSET,
						A.WORK_AREA,
						A.LINE_AREA,
						A.LINE_AREA_DESC,
						A.WORK_CENTER_BO,
						A.SHIFT,
						A.SHIFT_DESC,
						A.SHIFT_DURATION,
						CASE WHEN :start_date_time>SHIFT_START_DATE_TIME THEN :start_date_time ELSE SHIFT_START_DATE_TIME END AS SHIFT_START_DATE_TIME,
						CASE WHEN :end_date_time<SHIFT_END_DATE_TIME THEN :end_date_time ELSE SHIFT_END_DATE_TIME END AS SHIFT_END_DATE_TIME,
						A.RESOURCE_BO,
						A.RESOURCE_TYPE_DESCRIPTION,
						A.RESOURCE_TYPE,
						A.STARTDATE
						FROM :resrce_shift_end_date_time AS A;


	resrce_time_log_tmp = SELECT
				A.HANDLE,
				A.SITE,
				A.RESRCE,
				A.RESRCE_DESC,
				A.RESOURCE_TYPE_DESCRIPTION,
				A.RESOURCE_TYPE,
				A.ASSET,
				A.WORK_AREA,
				A.LINE_AREA,
				A.LINE_AREA_DESC,
				A.WORK_CENTER_BO,
				A.SHIFT,
				A.SHIFT_DESC,
				A.SHIFT_START_DATE_TIME,
				A.SHIFT_END_DATE_TIME,
				A.RESOURCE_BO,
				A.STARTDATE,
				null AS ME_USER_ID,
				B.START_DATE_TIME,
				B.END_DATE_TIME,
				B.ELAPSED_TIME,
				C.STATE AS RESOURCE_STATE,
				C.DESCRIPTION AS RESOURCE_STATE_DESC,
				C.STATE
	FROM :filter_resrce_shift_end_date_time AS A
	LEFT JOIN MHP_OEE.RESOURCE_TIME_LOG AS B ON B.SITE=A.SITE AND B.RESOURCE_BO=A.RESOURCE_BO
	AND ((B.START_DATE_TIME<A.SHIFT_START_DATE_TIME AND (B.END_DATE_TIME is null OR B.END_DATE_TIME>A.SHIFT_START_DATE_TIME))
	OR (B.START_DATE_TIME>A.SHIFT_START_DATE_TIME AND B.START_DATE_TIME<A.SHIFT_END_DATE_TIME))
	LEFT JOIN MHP_OEE.RESOURCE_STATE AS C ON  C.STATE=B.RESOURCE_STATE AND C.SITE=A.SITE
	WHERE A.SHIFT_END_DATE_TIME>A.SHIFT_START_DATE_TIME
	AND (
		B.END_DATE_TIME is not null
		or B.HANDLE  in(
			select HANDLE from(
				select  HANDLE,ROW_NUMBER() over(partition by rtl.RESOURCE_BO order by rtl.START_DATE_TIME desc) as num
				from MHP_OEE.RESOURCE_TIME_LOG rtl
				--where rtl.START_DATE_TIME > '2016-09-05 00:25:00'
				where rtl.END_DATE_TIME is null
				) a where a.num = 1
				--order by a.RESOURCE_BO
		)
	);


	resrce_time_log = SELECT
				A.HANDLE,
				A.SITE,
				A.RESRCE,
				A.RESRCE_DESC,
				A.RESOURCE_TYPE,
				A.RESOURCE_TYPE_DESCRIPTION,
				A.ASSET,
				A.WORK_AREA,
				A.LINE_AREA,
				A.LINE_AREA_DESC,
				A.WORK_CENTER_BO,
				A.SHIFT,
				A.SHIFT_DESC,
				A.SHIFT_START_DATE_TIME,
				A.SHIFT_END_DATE_TIME,
				A.RESOURCE_BO,
				A.STARTDATE,
				null AS ME_USER_ID,
				A.START_DATE_TIME,
				A.END_DATE_TIME,
				A.ELAPSED_TIME,
				A.STATE AS RESOURCE_STATE,
				A.RESOURCE_STATE_DESC
	FROM :resrce_time_log_tmp AS A
	WHERE A.STATE = 'D';


	/*查询结果*/
	all_collection =SELECT
			A.SITE,
		 	A.STARTDATE,
			A.RESRCE,
			A.RESRCE_DESC,
			A.RESOURCE_TYPE,
			A.RESOURCE_TYPE_DESCRIPTION,
			A.ASSET,
			A.LINE_AREA,
			A.LINE_AREA_DESC,
			A.SHIFT,
			A.SHIFT_DESC,
			A.SHIFT_START_DATE_TIME,
			A.SHIFT_END_DATE_TIME,
			A.RESOURCE_BO,
			A.ME_USER_ID,
			A.START_DATE_TIME,
			A.END_DATE_TIME,
			A.RESOURCE_STATE,
			A.RESOURCE_STATE_DESC,
			A.ELAPSED_TIME
	 FROM :resrce_time_log AS A;

	 intersection_time =SELECT
	 		A.SITE,
		 	A.STARTDATE,
			A.RESRCE,
			A.RESRCE_DESC,
			A.RESOURCE_TYPE,
			A.RESOURCE_TYPE_DESCRIPTION,
			A.ASSET,
			A.LINE_AREA,
			A.LINE_AREA_DESC,
			A.SHIFT,
			A.SHIFT_DESC,
			A.SHIFT_START_DATE_TIME,
			A.SHIFT_END_DATE_TIME,
			A.RESOURCE_BO,
			A.ME_USER_ID,
			A.START_DATE_TIME,
			A.END_DATE_TIME,
			CASE WHEN SHIFT_START_DATE_TIME > START_DATE_TIME THEN SHIFT_START_DATE_TIME ELSE START_DATE_TIME END AS INTERSECTION_START_TIME,
			CASE WHEN SHIFT_END_DATE_TIME < END_DATE_TIME THEN SHIFT_END_DATE_TIME ELSE END_DATE_TIME END AS INTERSECTION_END_TIME,
			A.RESOURCE_STATE,
			A.RESOURCE_STATE_DESC,
			A.ELAPSED_TIME
	 FROM :all_collection AS A;


	 intersection_time_with_fu = SELECT
	 		A.SITE,
	 		A.STARTDATE,
			A.RESRCE,
			A.RESRCE_DESC,
			A.RESOURCE_TYPE,
			A.RESOURCE_TYPE_DESCRIPTION,
			A.ASSET,
			A.LINE_AREA,
			A.LINE_AREA_DESC,
			A.SHIFT,
			A.SHIFT_DESC,
			A.SHIFT_START_DATE_TIME,
			A.SHIFT_END_DATE_TIME,
			A.RESOURCE_BO,
			A.ME_USER_ID,
			A.START_DATE_TIME,
			A.END_DATE_TIME,
			A.INTERSECTION_START_TIME,
			CASE WHEN A.INTERSECTION_END_TIME is null THEN now() ELSE A.INTERSECTION_END_TIME END AS INTERSECTION_END_TIME,
			null AS INTERSECTION_TIME_DURATION,
			A.RESOURCE_STATE,
			A.RESOURCE_STATE_DESC,
			A.ELAPSED_TIME
			FROM :intersection_time AS A;


		cal_duration= SELECT
	 		A.SITE,
	 		A.STARTDATE,
			A.RESRCE,
			A.RESRCE_DESC,
			A.RESOURCE_TYPE,
			A.RESOURCE_TYPE_DESCRIPTION,
			A.ASSET,
			A.LINE_AREA,
			A.LINE_AREA_DESC,
			A.SHIFT,
			A.SHIFT_DESC,
			A.SHIFT_START_DATE_TIME,
			A.SHIFT_END_DATE_TIME,
			A.RESOURCE_BO,
			A.ME_USER_ID,
			A.START_DATE_TIME,
			A.END_DATE_TIME,
			A.INTERSECTION_START_TIME,
			A.INTERSECTION_END_TIME,
			SECONDS_BETWEEN(A.INTERSECTION_START_TIME, A.INTERSECTION_END_TIME) AS INTERSECTION_TIME_DURATION,
			A.RESOURCE_STATE,
			A.RESOURCE_STATE_DESC,
			A.ELAPSED_TIME
			FROM :intersection_time_with_fu AS A;


			sub_time= SELECT
	 		A.SITE,
	 		A.STARTDATE,
			A.RESRCE,
			A.RESRCE_DESC,
			A.RESOURCE_TYPE,
			A.RESOURCE_TYPE_DESCRIPTION,
			A.ASSET,
			A.LINE_AREA,
			A.LINE_AREA_DESC,
			A.SHIFT,
			A.SHIFT_DESC,
			A.SHIFT_START_DATE_TIME,
			A.SHIFT_END_DATE_TIME,
			A.RESOURCE_BO,
			A.ME_USER_ID,
			A.START_DATE_TIME,
			A.END_DATE_TIME,
			CASE WHEN SHIFT_START_DATE_TIME > INTERSECTION_START_TIME THEN SHIFT_START_DATE_TIME ELSE INTERSECTION_START_TIME END AS INTERSECTION_START_TIME,
			CASE WHEN SHIFT_END_DATE_TIME < INTERSECTION_END_TIME THEN SHIFT_END_DATE_TIME ELSE INTERSECTION_END_TIME END AS INTERSECTION_END_TIME,
			/*
			A.INTERSECTION_START_TIME,
			A.INTERSECTION_END_TIME,*/
			A.INTERSECTION_TIME_DURATION,
			A.RESOURCE_STATE,
			A.RESOURCE_STATE_DESC,
			A.ELAPSED_TIME
			FROM :cal_duration AS A;



	intersection_time_without_fu = SELECT
			A.SITE,
	 		A.STARTDATE,
			A.RESRCE,
			A.RESRCE_DESC,
			A.RESOURCE_TYPE,
			A.RESOURCE_TYPE_DESCRIPTION,
			A.ASSET,
			A.LINE_AREA,
			A.LINE_AREA_DESC,
			A.SHIFT,
			A.SHIFT_DESC,
			A.SHIFT_START_DATE_TIME,
			A.SHIFT_END_DATE_TIME,
			A.RESOURCE_BO,
			A.ME_USER_ID,
			A.START_DATE_TIME,
			A.END_DATE_TIME,
			A.INTERSECTION_START_TIME,
			A.INTERSECTION_END_TIME,
			SECONDS_BETWEEN(A.INTERSECTION_START_TIME, A.INTERSECTION_END_TIME) AS INTERSECTION_TIME_DURATION,
			A.RESOURCE_STATE,
			A.RESOURCE_STATE_DESC,
			A.ELAPSED_TIME
			FROM :sub_time AS A
			WHERE A.INTERSECTION_TIME_DURATION >= 0;

	/*给RESOURCE_REASON_LOG瘦身*/
	var_intersection_time_without_fu_temp = select
			SITE,
			RESRCE,
			INTERSECTION_START_TIME,
			INTERSECTION_END_TIME
			from :intersection_time_without_fu;
	var_result_reason_code_temp = select
			A.SITE,
			A.DATE_TIME,
			A.REASON_CODE,
			A.RESRCE,
			A.ME_USER_ID,
			A.ACTION_CODE
			FROM MHP_OEE.RESOURCE_REASON_LOG A
			left JOIN :var_intersection_time_without_fu_temp B
			ON A.SITE = B.SITE AND A.RESRCE=B.RESRCE
			AND A.DATE_TIME < B.INTERSECTION_END_TIME
			AND A.ACTION_CODE = 'START'
			WHERE A.DATE_TIME >= B.INTERSECTION_START_TIME
			AND A.DATE_TIME < B.INTERSECTION_END_TIME
			AND A.ACTION_CODE = 'START'	;

	result_reason_code = SELECT
				A.STARTDATE,
				A.RESRCE,
				A.RESRCE_DESC,
				A.RESOURCE_TYPE,
				A.RESOURCE_TYPE_DESCRIPTION,
				A.ASSET,
				A.LINE_AREA,
				A.LINE_AREA_DESC,
				A.SHIFT,
				A.SHIFT_DESC,
				A.SHIFT_START_DATE_TIME,
				A.SHIFT_END_DATE_TIME,
				A.RESOURCE_BO,
				A.ME_USER_ID,
				B.ME_USER_ID AS USER_ID,
				A.START_DATE_TIME,
				A.END_DATE_TIME,
				A.INTERSECTION_START_TIME,
				A.INTERSECTION_END_TIME,
				A.INTERSECTION_TIME_DURATION,
				A.RESOURCE_STATE,
				A.RESOURCE_STATE_DESC,
				A.ELAPSED_TIME,
				NULL AS USER_BO,
				B.DATE_TIME AS REASON_CODE_TIME,
				B.REASON_CODE,
				C.DESCRIPTION AS REASON_CODE_DESCRIPTION,
				NULL AS LOGIN_DATE_TIME
			FROM :intersection_time_without_fu AS A
			INNER JOIN :var_result_reason_code_temp AS B
				ON A.SITE = B.SITE AND A.RESRCE=B.RESRCE
				AND B.DATE_TIME >= A.INTERSECTION_START_TIME
				AND B.DATE_TIME < A.INTERSECTION_END_TIME
			INNER JOIN MHP_OEE.REASON_CODE AS C
				ON B.REASON_CODE = C.REASON_CODE AND B.SITE = C.SITE;


	 var_out = SELECT *, 1 AS QTY FROM :result_reason_code;

 END /********* End Procedure Script ************/